Loading...
Searching...
No Matches
casacore::LCLELMask Class Reference
lattices package (libcasa_lattices) » LRegions_module

More...

`#include <LCLELMask.h>`

## Public Member Functions

| LCLELMask ()
| LCLELMask (const LatticeExpr< Bool > &expr)
| Construct from vectors of world coordinates defining the box corners.
| LCLELMask (const LCLELMask &other)
| Copy constructor (copy semantics).
virtual | ~LCLELMask ()
| Destructor.
LCLELMask & | operator= (const LCLELMask &other)
| Assignment (copy semantics).
virtual Bool | operator== (const LCRegion &other) const
| Comparison.
virtual LCRegion * | cloneRegion () const
| Clone a LCLELMask object.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Handle the (un)locking.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the PagedArray object with the lattice file.
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
virtual String | type () const
| Return region type.
virtual TableRecord | toRecord (const String &tableName) const
| Convert the LCLELMask object to a record.
Public Member Functions inherited from casacore::LCRegionSingle
| LCRegionSingle ()
| LCRegionSingle (const IPosition &latticeShape)
| Construct with the lattice shape only.
| LCRegionSingle (const LCRegionSingle &other)
| Copy constructor (copy semantics).
virtual | ~LCRegionSingle ()
virtual Bool | hasMask () const
| Does the region have a mask?
const Array< Bool > | maskArray () const
| Get the mask (as an array).
Bool | masksEqual (const LCRegion &other) const
| Is the mask of this region the same as the mask of the other.
virtual void | set (const Bool &value)
| The following "put" functions are described in detail in class Lattice.
virtual void | apply (Bool(*function)(Bool))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (Bool(*function)(const Bool &))
virtual void | apply (const Functional< Bool, Bool > &function)
virtual void | putAt (const Bool &value, const IPosition &where)
| Put the value of a single element.
virtual void | copyData (const Lattice< Bool > &from)
| Copy the data from the given lattice to this one.
Public Member Functions inherited from casacore::LCRegion
| LCRegion ()
| LCRegion (const IPosition &latticeShape)
| Construct with the lattice shape only.
| LCRegion (const LCRegion &other)
| Copy constructor (copy semantics).
virtual | ~LCRegion ()
Bool | operator!= (const LCRegion &other) const
| Non-equality.
virtual Lattice< Bool > * | clone () const
| Make a copy of the derived object.
virtual void | handleDelete ()
| Handle deletion of the region by deleting possible tables.
virtual void | handleRename (const String &newName, Bool overwrite)
| Handle renaming the region by renaming possible tables.
const String & | comment () const
| Get or set the comment.
void | setComment (const String &comment)
LCRegion * | translate (const IPosition &translateVector) const
| Construct another LCRegion (for e.g.
LCRegion * | translate (const IPosition &translateVector, const IPosition &newLatticeShape) const
LCRegion * | translate (const Vector< Float > &translateVector) const
LCRegion * | translate (const Vector< Float > &translateVector, const IPosition &newLatticeShape) const
const IPosition & | latticeShape () const
| Give the full lattice shape.
const Slicer & | boundingBox () const
| Give the bounding box.
Slicer | expand (const Slicer &slicer) const
| Expand a slicer or position in the region to the full lattice.
IPosition | expand (const IPosition &index) const
virtual uInt | ndim () const
| Return the dimensionality of the region.
virtual IPosition | shape () const
| Return the shape of the region (i.e.
virtual Bool | isWritable () const
| Usually the lattice (i.e.
Public Member Functions inherited from casacore::Lattice< Bool >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
Bool | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual Bool | getAt (const IPosition &where) const
Bool | get (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | put (const Array< Bool > &sourceBuffer)
void | operator+= (const Lattice< Bool > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< Bool > &other)
void | operator*= (const Lattice< Bool > &other)
void | operator/= (const Lattice< Bool > &other)
virtual void | copyDataTo (Lattice< Bool > &to) const
| Copy the data from this lattice to the given lattice.
virtual uInt | advisedMaxPixels () const
| This function returns the advised maximum number of pixels to include in the cursor of an iterator.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual String | name (Bool stripPath=False) const
| Return the name of the current Lattice object.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
virtual LELCoordinates | lelCoordinates () const
| Return the coordinates of the lattice.
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual Bool | ok () const
| Check class internals - used for debugging.
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Static Public Member Functions

static String | className ()
| Returns LCLELMask.
Static Public Member Functions inherited from casacore::LCRegion
static LCRegion * | fromRecord (const TableRecord &, const String &tableName)
| Convert correct object from a record.

## Protected Member Functions

virtual LCRegion * | doTranslate (const Vector< Float > &translateVector, const IPosition &newLatticeShape) const
| Translating an LCLELMask is not possible, so it throws an exception.
Protected Member Functions inherited from casacore::LCRegionSingle
LCRegionSingle & | operator= (const LCRegionSingle &other)
| Assignment (copy semantics) is only useful for derived classes.
void | setMaskPtr (Lattice< Bool > &mask)
| Set the pointer to the mask in the derived class.
virtual Bool | doGetSlice (Array< Bool > &buffer, const Slicer &section)
| Do the actual getting of the mask.
virtual void | doPutSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| Do the actual putting of the mask.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| Get the best cursor shape.
virtual LatticeIterInterface< Bool > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| Make an iterator.
Protected Member Functions inherited from casacore::LCRegion
LCRegion & | operator= (const LCRegion &other)
| Assignment (copy semantics) is only useful for derived classes.
void | setBoundingBox (const Slicer &boundingBox)
| Sometimes it is inconvenient for a derived class to set the bounding box in the constructor.
void | setShapeAndBoundingBox (const IPosition &latticeShape, const Slicer &boundingBox)
void | defineRecordFields (RecordInterface &record, const String &className) const
| Define the type and class name in the record.
Protected Member Functions inherited from casacore::Lattice< Bool >
void | handleMathTo (Lattice< Bool > &, int) const
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< Bool > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
Lattice< Bool > & | operator= (const Lattice< Bool > &)
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Private Attributes

LCBox | itsBox
LatticeExpr< Bool > | itsExpr

## Detailed Description

Class to define a mask as a LEL expression

### Intended use:

Public interface

### Prerequisite

- LCRegion
- ImageExpr

### Synopsis

The LCLELMask class is a specialization of class LCRegion.
It can be used to define an on-the-fly mask for a lattice using a boolean LatticeExpr. The contents of the mask are calculated on the fly from the expression. Thus the mask may change if the data in the lattice(s) used in the expression change.
Caution: This mask is not persistent, thus it cannot be saved with an image; Use class WCLELMask to have a persistent on-the-fly mask; It means that normally a WCLELMask should be used (which gets converted to an LCLELMask when applied to an image);

### Example

### Motivation

LCLELMask is needed to make

Definition at line 87 of file LCLELMask.h.

## Constructor & Destructor Documentation

## LCLELMask() [1/3]

casacore::LCLELMask::LCLELMask | ( |  | ) |

Referenced by LCLELMask(), and operator=().

## LCLELMask() [2/3]

casacore::LCLELMask::LCLELMask | ( | const LatticeExpr< Bool > & | expr | ) |

explicit

Construct from vectors of world coordinates defining the box corners.

It is assumed that the order of the values is in the order of the pixel axes.

## LCLELMask() [3/3]

casacore::LCLELMask::LCLELMask | ( | const LCLELMask & | other | ) |

Copy constructor (copy semantics).

References LCLELMask().

## ~LCLELMask()

virtual casacore::LCLELMask::~LCLELMask | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## className()

String casacore::LCLELMask::className | ( |  | ) |

static

Returns LCLELMask.

## cloneRegion()

virtual LCRegion * casacore::LCLELMask::cloneRegion | ( |  | ) | const

virtual

Clone a LCLELMask object.

Implements casacore::LCRegion.

## doTranslate()

virtual LCRegion * casacore::LCLELMask::doTranslate | ( | const Vector< Float > & | translateVector,
|  | const IPosition & | newLatticeShape ) const

protected virtual

Translating an LCLELMask is not possible, so it throws an exception.

Implements casacore::LCRegion.

## hasLock()

virtual Bool casacore::LCLELMask::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Reimplemented from casacore::LatticeBase.

## lock()

virtual Bool casacore::LCLELMask::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

Handle the (un)locking.

Reimplemented from casacore::LatticeBase.

## operator=()

LCLELMask & casacore::LCLELMask::operator= | ( | const LCLELMask & | other | ) |

Assignment (copy semantics).

References LCLELMask().

## operator==()

virtual Bool casacore::LCLELMask::operator== | ( | const LCRegion & | other | ) | const

virtual

Comparison.

Reimplemented from casacore::LCRegion.

## reopen()

virtual void casacore::LCLELMask::reopen | ( |  | ) |

virtual

Explicitly reopen the temporarily closed lattice.

Reimplemented from casacore::LatticeBase.

## resync()

virtual void casacore::LCLELMask::resync | ( |  | ) |

virtual

Resynchronize the PagedArray object with the lattice file.

This function is only useful if no read-locking is used, ie. if the table lock option is UserNoReadLocking or AutoNoReadLocking. In that cases the table system does not acquire a read-lock, thus does not synchronize itself automatically.

Reimplemented from casacore::LatticeBase.

## tempClose()

virtual void casacore::LCLELMask::tempClose | ( |  | ) |

virtual

Temporarily close the lattice.

It will be reopened automatically on the next access.

Reimplemented from casacore::LatticeBase.

## toRecord()

virtual TableRecord casacore::LCLELMask::toRecord | ( | const String & | tableName | ) | const

virtual

Convert the LCLELMask object to a record.

This cannot be done as a Lattice expression cannot be made persistent (only Image expressions can, thus only WCLELMask is persistent).
So this function throws an exception.

Implements casacore::LCRegion.

## type()

virtual String casacore::LCLELMask::type | ( |  | ) | const

virtual

Return region type.

Returns the class name

Implements casacore::LCRegion.

## unlock()

virtual void casacore::LCLELMask::unlock | ( |  | ) |

virtual

Reimplemented from casacore::LatticeBase.

## Member Data Documentation

## itsBox

LCBox casacore::LCLELMask::itsBox

private

Definition at line 152 of file LCLELMask.h.

## itsExpr

LatticeExpr<Bool> casacore::LCLELMask::itsExpr

private

Definition at line 153 of file LCLELMask.h.

The documentation for this class was generated from the following file:

- lattices/LRegions/LCLELMask.h